#import "FlulmAuthPlugin.h"
#import "LemaAPI.h"
#import "FluwxStringUtil.h"
#import "FluwxAuthHandler.h"
@implementation FlulmAuthPlugin
FluwxAuthHandler *_fluwxAuthHandler;


BOOL isWeChatRegistered = NO;



+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"com.awesome/flulm_auth"
            binaryMessenger:[registrar messenger]];
    
  FlulmAuthPlugin* instance = [[FlulmAuthPlugin alloc] initWithRegistrar:registrar methodChannel:channel];
  [registrar addApplicationDelegate:instance];
  [registrar addMethodCallDelegate:instance channel:channel];

}

- (instancetype)initWithRegistrar:(NSObject <FlutterPluginRegistrar> *)registrar methodChannel:(FlutterMethodChannel *)flutterMethodChannel {
    
    self = [super init];
    if (self) {
        _fluwxAuthHandler = [[FluwxAuthHandler alloc] initWithRegistrar:registrar methodChannel:flutterMethodChannel];;
    }

    return self;
}




- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  }else if ([@"registerApp" isEqualToString:call.method]) {
      printf("registerApp==>");
      [self registerApp:call result:result];
   } else if ([@"sendAuth" isEqualToString:call.method]) {
        printf("sendAuth==>");
       [_fluwxAuthHandler handleAuth:call result:result];
  }else if ([@"isLemaPayInstalled" isEqualToString:call.method]) {
     printf("call isLemaPayInstalled====");
      result(@YES);
  }else if ([@"isLemaPaySupportAPI" isEqualToString:call.method]) {
     printf("call isLemaPaySupportAPI===");
      result(@YES);
//      result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  }else {
    result(FlutterMethodNotImplemented);
  }
}

-(BOOL)application:(UIApplication *)application openURL:(NSURL *)url options:(NSDictionary<UIApplicationOpenURLOptionsKey,id> *)options{
    [_fluwxAuthHandler handelUrl:url];
    return YES;
}

- (void)registerApp:(FlutterMethodCall *)call result:(FlutterResult)result {
    if (!call.arguments[@"iOS"]) {
        result(@NO);
        return;
    }

    NSString *appId = call.arguments[@"appId"];
    if ([FluwxStringUtil isBlank:appId]) {
        result([FlutterError errorWithCode:@"invalid app id" message:@"are you sure your app id is correct ? " details:appId]);
        return;
    }

    NSString *universalLink = call.arguments[@"universalLink"];

//    if ([FluwxStringUtil isBlank:universalLink]) {
//        result([FlutterError errorWithCode:@"invalid universal link" message:@"are you sure your universal link is correct ? " details:universalLink]);
//        return;
//    }

     [LemaAPI registerAPP:appId secret:universalLink];

    result(@YES);
}

@end
